/**
 * 启动脚本
 */

var appManager = {
    authReqKey: "",   //授权请求Key
    gameInfo : {},
    sdkInfo : {},
    userInfo : {},

    init: function() {
        this.gameInfo = sdkB.request(sdkB.servType.COMMON, sdkB.actions.GET_GAME_INFO);
        this.sdkInfo = sdkB.request(sdkB.servType.COMMON, sdkB.actions.GET_SDK_INFO);
        this.userInfo = sdkB.request(sdkB.servType.COMMON, sdkB.actions.GET_CURR_USER);

        var gameId = this.gameInfo.data.gameId;
        var serverId = this.gameInfo.data.serverId;
        var os = this.sdkInfo.data.os;
        var sid = this.userInfo.data.sid;

        var reqData = "gid=" + gameId + "&os=" + os + "&srid=" + serverId + "&sid=" + sid;
        //加载动态数据（授权支付方式）
        this.authReqKey = SecurityUtil.randomKey(16);
        mainUrl = authUrl + "?" + "data=" + this.encAuthReqData(reqData, this.authReqKey);

        //如果是开发模式，将明文返回授权信息，如果否，将加密传输，返回变量_authData
        if(devMode) mainUrl += "&devMode=1";
        var script = document.createElement('script');
        script.src = mainUrl;
        script.onload = this.onLoad;
        $("head").append(script);
    },
    //加密授权请求的数据
    encAuthReqData: function(data, key) {
        var certStore = new CertStore();
        certStore.load("ugc_cert"); //从本地存储加载最新的内容
        var sKey = SecurityUtil.rsaEncrypt(key, certStore.get("data"));
        var sData = SecurityUtil.aesEncrypt(data, key);
        return certStore.get("ver") + "|" + sKey + "|" + sData;
    },
    //授权脚本加载完成后，执行该脚本
    onLoad: function() {
        //获取渲染脚本
        if (devMode) {
            $("#_js").attr("src", updUrl + "?devMode=1&t=" + new Date().getTime());
        } else {
            //解密返回的授权和会话信息
            if(typeof(_authData)!="undefined" && _authData) {
                var authData = SecurityUtil.aesDecrypt(_authData, appManager.authReqKey);
                window.eval(authData);

                //从H5缓存读取渲染脚本
                var jStore = jsManager.getJStore();
                $("#_js").text(Base64.decode(jStore.get("data")));
                console.log("当前渲染版本: " + jStore.get("ver"));

                //进行异步更新渲染脚本
                setTimeout(jsManager.update, 500);
                //进行异步更新资源(证书、广告、温馨提示、日志打点配置等)
                try{
                    setTimeout(resManager.update, 1000);
                } catch(ex) {
                    console.log("资源更新异常: " + ex);
                }
            } else {
                //没有返回授权信息，直接返回游戏
                sdkB.request(sdkB.servType.PAY, sdkB.actions.EXIT_SDK);
            }
        }
    }
};

//渲染脚本管理器
var jsManager = {
    code: "ugc_js",    //本地存储的标识
    getJStore: function() {
        var jStore = new JStore();
        jStore.load(this.code);

        return jStore;
    },
    //更新渲染脚本
    update : function() {
        var jStore = jsManager.getJStore();
        if(jStore.needUpdate()) {
            var bTime = new Date();
            //准备请求的数据
            var gameId = appManager.gameInfo.data.gameId;
            var srcData = "gameId=" + gameId + "&ver=" + jStore.get("ver");
            var reqData = sessionId + "|" + SecurityUtil.aesEncrypt(srcData, sessionKey);
            $.ajax({
                type: "GET",
                url: updUrl + "?data=" + reqData,
                dataType: "jsonp",
                timeout: 30000,
                success: function (rsp) {
                    if(rsp.jsData) {
                        var jStore = new JStore();
                        var data = SecurityUtil.aesDecrypt(rsp.jsData, sessionKey);
                        if(data) {
                            jStore.parse(data);
                            jStore.save(jsManager.code);
                            console.log("脚本更新: 完成 [版本:" + jStore.get("ver") +", 耗时:" + (new Date()-bTime) + "ms]");
                        }
                    }
                },
                error: function (xhr, type) {
                    console.log("脚本更新: 网络异常");
                }
            });
        }
    }
};